import { jsx } from '@antv/f-engine';
import { deepMix } from '@antv/util';
import Lottie from '@antv/f-lottie';
var defaultProps = {
  offsetX: 0,
  offsetY: 0,
  points: [],
  data: '',
  animation: null,
  options: {
    loop: true,
    autoplay: true
  }
};
export default (function (props, context) {
  var cfg = deepMix({}, defaultProps, props);
  var points = cfg.points,
    style = cfg.style,
    offsetX = cfg.offsetX,
    offsetY = cfg.offsetY,
    lottieJson = cfg.lottieJson,
    animation = cfg.animation,
    option = cfg.option;
  var _ref = points[0] || {},
    x = _ref.x,
    y = _ref.y;
  var _style$height = style.height,
    height = _style$height === void 0 ? 0 : _style$height,
    _style$width = style.width,
    width = _style$width === void 0 ? 0 : _style$width;
  var offsetXNum = context.px2hd(offsetX);
  var offsetYNum = context.px2hd(offsetY);
  var posX = x + (offsetXNum || 0) - height / 2;
  var posY = y + (offsetYNum || 0) - width / 2;
  return jsx(Lottie, {
    data: lottieJson,
    options: option,
    style: {
      x: posX,
      y: posY,
      width: width,
      height: height
    },
    animation: deepMix({
      update: {
        easing: 'linear',
        duration: 450,
        property: ['x', 'y']
      }
    }, animation)
  });
});