import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import Coord, { Rect, Polar } from '../coord';
import { isString, isFunction } from '@antv/util';
var coordMap = {
  rect: Rect,
  polar: Polar
};
var coordController = /*#__PURE__*/function () {
  function coordController() {
    _classCallCheck(this, coordController);
  }
  _createClass(coordController, [{
    key: "getOption",
    value: function getOption(cfg) {
      if (isString(cfg)) {
        return {
          type: coordMap[cfg] || Rect
        };
      }
      if (isFunction(cfg)) {
        return {
          type: cfg
        };
      }
      var _ref = cfg || {},
        type = _ref.type;
      return _objectSpread(_objectSpread({}, cfg), {}, {
        // 默认直角坐标系
        type: isFunction(type) ? type : coordMap[type] || Rect
      });
    }
  }, {
    key: "create",
    value: function create(cfg) {
      var layout = this.layout;
      var option = this.getOption(cfg);
      var type = option.type;
      var coord = new type(_objectSpread(_objectSpread({}, option), layout));
      this.coord = coord;
      return coord;
    }
  }, {
    key: "updateLayout",
    value: function updateLayout(style) {
      var coord = this.coord;
      var left = style.left,
        top = style.top,
        width = style.width,
        height = style.height,
        padding = style.padding;
      var _ref2 = padding || [0, 0, 0, 0],
        _ref3 = _slicedToArray(_ref2, 4),
        paddingTop = _ref3[0],
        paddingRight = _ref3[1],
        paddingBottom = _ref3[2],
        paddingLeft = _ref3[3];
      this.layout = {
        left: left + paddingLeft,
        top: top + paddingTop,
        width: width - paddingLeft - paddingRight,
        height: height - paddingTop - paddingBottom
      };
      if (coord) {
        coord.update(this.layout);
      }
    }
  }, {
    key: "useLayout",
    value: function useLayout(positionLayout) {
      var coord = this.coord;
      var position = positionLayout.position,
        boxWidth = positionLayout.width,
        boxHeight = positionLayout.height;
      var left = coord.left,
        top = coord.top,
        width = coord.width,
        height = coord.height;
      switch (position) {
        case 'left':
          left += boxWidth;
          width = Math.max(0, width - boxWidth);
          break;
        case 'right':
          width = Math.max(0, width - boxWidth);
          break;
        case 'top':
          top += boxHeight;
          height = Math.max(0, height - boxHeight);
          break;
        case 'bottom':
          height = Math.max(0, height - boxHeight);
          break;
      }
      coord.update({
        left: left,
        top: top,
        width: width,
        height: height
      });
    }
  }, {
    key: "update",
    value: function update() {}
  }, {
    key: "getCoord",
    value: function getCoord() {
      return this.coord;
    }
  }]);
  return coordController;
}();
export { Coord };
export default coordController;