import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as _ from '@antv/util';
import { DODGE_RATIO, MARGIN_RATIO } from '../constant';
import Adjust from './adjust';
var Dodge = /*#__PURE__*/function (_Adjust) {
  _inherits(Dodge, _Adjust);
  var _super = _createSuper(Dodge);
  function Dodge(cfg) {
    var _this;
    _classCallCheck(this, Dodge);
    _this = _super.call(this, cfg);
    _this.cacheMap = {};
    _this.adjustDataArray = [];
    _this.mergeData = [];
    var _cfg$marginRatio = cfg.marginRatio,
      marginRatio = _cfg$marginRatio === void 0 ? MARGIN_RATIO : _cfg$marginRatio,
      _cfg$dodgeRatio = cfg.dodgeRatio,
      dodgeRatio = _cfg$dodgeRatio === void 0 ? DODGE_RATIO : _cfg$dodgeRatio,
      dodgeBy = cfg.dodgeBy,
      intervalPadding = cfg.intervalPadding,
      dodgePadding = cfg.dodgePadding,
      xDimensionLength = cfg.xDimensionLength,
      groupNum = cfg.groupNum,
      defaultSize = cfg.defaultSize,
      maxColumnWidth = cfg.maxColumnWidth,
      minColumnWidth = cfg.minColumnWidth,
      columnWidthRatio = cfg.columnWidthRatio,
      customOffset = cfg.customOffset;
    _this.marginRatio = marginRatio;
    _this.dodgeRatio = dodgeRatio;
    _this.dodgeBy = dodgeBy;
    _this.intervalPadding = intervalPadding;
    _this.dodgePadding = dodgePadding;
    _this.xDimensionLegenth = xDimensionLength;
    _this.groupNum = groupNum;
    _this.defaultSize = defaultSize;
    _this.maxColumnWidth = maxColumnWidth;
    _this.minColumnWidth = minColumnWidth;
    _this.columnWidthRatio = columnWidthRatio;
    _this.customOffset = customOffset;
    return _this;
  }
  _createClass(Dodge, [{
    key: "process",
    value: function process(groupDataArray) {
      var groupedDataArray = _.clone(groupDataArray);
      // 将数据数组展开一层
      var mergeData = _.flatten(groupedDataArray);
      var dodgeBy = this.dodgeBy;
      // 如果指定了分组 dim 的字段
      var adjustDataArray = dodgeBy ? _.group(mergeData, dodgeBy) : groupedDataArray;
      this.cacheMap = {};
      this.adjustDataArray = adjustDataArray;
      this.mergeData = mergeData;
      this.adjustData(adjustDataArray, mergeData);
      this.adjustDataArray = [];
      this.mergeData = [];
      return groupedDataArray;
    }
  }, {
    key: "adjustDim",
    value: function adjustDim(dim, values, data, frameIndex) {
      var _this2 = this;
      var customOffset = this.customOffset;
      var map = this.getDistribution(dim);
      var groupData = this.groupData(data, dim); // 根据值分组
      _.each(groupData, function (group, key) {
        var range;
        // xField 中只有一个值，不需要做 dodge
        if (values.length === 1) {
          range = {
            pre: values[0] - 1,
            next: values[0] + 1
          };
        } else {
          // 如果有多个，则需要获取调整的范围
          range = _this2.getAdjustRange(dim, parseFloat(key), values);
        }
        _.each(group, function (d) {
          var value = d[dim];
          var valueArr = map[value];
          var valIndex = valueArr.indexOf(frameIndex);
          if (!_.isNil(customOffset)) {
            var _range = range,
              pre = _range.pre,
              next = _range.next;
            d[dim] = _.isFunction(customOffset) ? customOffset(d, range) : (pre + next) / 2 + customOffset;
          } else {
            d[dim] = _this2.getDodgeOffset(range, valIndex, valueArr.length);
          }
        });
      });
      return [];
    }
  }, {
    key: "getDodgeOffset",
    value: function getDodgeOffset(range, idx, len) {
      var dodgeRatio = this.dodgeRatio,
        marginRatio = this.marginRatio,
        intervalPadding = this.intervalPadding,
        dodgePadding = this.dodgePadding;
      var pre = range.pre,
        next = range.next;
      var tickLength = next - pre;
      var position;
      // 分多种输入情况
      if (!_.isNil(intervalPadding) && _.isNil(dodgePadding) && intervalPadding >= 0) {
        // 仅配置intervalPadding
        var offset = this.getIntervalOnlyOffset(len, idx);
        position = pre + offset;
      } else if (!_.isNil(dodgePadding) && _.isNil(intervalPadding) && dodgePadding >= 0) {
        // 仅配置dodgePadding
        var _offset = this.getDodgeOnlyOffset(len, idx);
        position = pre + _offset;
      } else if (!_.isNil(intervalPadding) && !_.isNil(dodgePadding) && intervalPadding >= 0 && dodgePadding >= 0) {
        // 同时配置intervalPadding和dodgePadding
        var _offset2 = this.getIntervalAndDodgeOffset(len, idx);
        position = pre + _offset2;
      } else {
        // 默认情况
        var width = tickLength * dodgeRatio / len;
        var margin = marginRatio * width;
        var _offset3 = 1 / 2 * (tickLength - len * width - (len - 1) * margin) + ((idx + 1) * width + idx * margin) - 1 / 2 * width - 1 / 2 * tickLength;
        position = (pre + next) / 2 + _offset3;
      }
      return position;
    }
  }, {
    key: "getIntervalOnlyOffset",
    value: function getIntervalOnlyOffset(len, idx) {
      var defaultSize = this.defaultSize,
        intervalPadding = this.intervalPadding,
        xDimensionLegenth = this.xDimensionLegenth,
        groupNum = this.groupNum,
        dodgeRatio = this.dodgeRatio,
        maxColumnWidth = this.maxColumnWidth,
        minColumnWidth = this.minColumnWidth,
        columnWidthRatio = this.columnWidthRatio;
      var normalizedIntervalPadding = intervalPadding / xDimensionLegenth;
      var normalizedDodgePadding = (1 - (groupNum - 1) * normalizedIntervalPadding) / groupNum * dodgeRatio / (len - 1);
      var geomWidth = ((1 - normalizedIntervalPadding * (groupNum - 1)) / groupNum - normalizedDodgePadding * (len - 1)) / len;
      // 根据columnWidthRatio/defaultSize/maxColumnWidth/minColumnWidth调整宽度
      geomWidth = !_.isNil(columnWidthRatio) ? 1 / groupNum / len * columnWidthRatio : geomWidth;
      if (!_.isNil(maxColumnWidth)) {
        var normalizedMaxWidht = maxColumnWidth / xDimensionLegenth;
        geomWidth = Math.min(geomWidth, normalizedMaxWidht);
      }
      if (!_.isNil(minColumnWidth)) {
        var normalizedMinWidht = minColumnWidth / xDimensionLegenth;
        geomWidth = Math.max(geomWidth, normalizedMinWidht);
      }
      geomWidth = defaultSize ? defaultSize / xDimensionLegenth : geomWidth;
      // 调整组内间隔
      normalizedDodgePadding = ((1 - (groupNum - 1) * normalizedIntervalPadding) / groupNum - len * geomWidth) / (len - 1);
      var offset = ((1 / 2 + idx) * geomWidth + idx * normalizedDodgePadding + 1 / 2 * normalizedIntervalPadding) * groupNum - normalizedIntervalPadding / 2;
      return offset;
    }
  }, {
    key: "getDodgeOnlyOffset",
    value: function getDodgeOnlyOffset(len, idx) {
      var defaultSize = this.defaultSize,
        dodgePadding = this.dodgePadding,
        xDimensionLegenth = this.xDimensionLegenth,
        groupNum = this.groupNum,
        marginRatio = this.marginRatio,
        maxColumnWidth = this.maxColumnWidth,
        minColumnWidth = this.minColumnWidth,
        columnWidthRatio = this.columnWidthRatio;
      var normalizedDodgePadding = dodgePadding / xDimensionLegenth;
      var normalizedIntervalPadding = 1 * marginRatio / (groupNum - 1);
      var geomWidth = ((1 - normalizedIntervalPadding * (groupNum - 1)) / groupNum - normalizedDodgePadding * (len - 1)) / len;
      // 根据columnWidthRatio/defaultSize/maxColumnWidth/minColumnWidth调整宽度
      geomWidth = columnWidthRatio ? 1 / groupNum / len * columnWidthRatio : geomWidth;
      if (!_.isNil(maxColumnWidth)) {
        var normalizedMaxWidht = maxColumnWidth / xDimensionLegenth;
        geomWidth = Math.min(geomWidth, normalizedMaxWidht);
      }
      if (!_.isNil(minColumnWidth)) {
        var normalizedMinWidht = minColumnWidth / xDimensionLegenth;
        geomWidth = Math.max(geomWidth, normalizedMinWidht);
      }
      geomWidth = defaultSize ? defaultSize / xDimensionLegenth : geomWidth;
      // 调整组间距
      normalizedIntervalPadding = (1 - (geomWidth * len + normalizedDodgePadding * (len - 1)) * groupNum) / (groupNum - 1);
      var offset = ((1 / 2 + idx) * geomWidth + idx * normalizedDodgePadding + 1 / 2 * normalizedIntervalPadding) * groupNum - normalizedIntervalPadding / 2;
      return offset;
    }
  }, {
    key: "getIntervalAndDodgeOffset",
    value: function getIntervalAndDodgeOffset(len, idx) {
      var intervalPadding = this.intervalPadding,
        dodgePadding = this.dodgePadding,
        xDimensionLegenth = this.xDimensionLegenth,
        groupNum = this.groupNum;
      var normalizedIntervalPadding = intervalPadding / xDimensionLegenth;
      var normalizedDodgePadding = dodgePadding / xDimensionLegenth;
      var geomWidth = ((1 - normalizedIntervalPadding * (groupNum - 1)) / groupNum - normalizedDodgePadding * (len - 1)) / len;
      var offset = ((1 / 2 + idx) * geomWidth + idx * normalizedDodgePadding + 1 / 2 * normalizedIntervalPadding) * groupNum - normalizedIntervalPadding / 2;
      return offset;
    }
  }, {
    key: "getDistribution",
    value: function getDistribution(dim) {
      var groupedDataArray = this.adjustDataArray;
      var cacheMap = this.cacheMap;
      var map = cacheMap[dim];
      if (!map) {
        map = {};
        _.each(groupedDataArray, function (data, index) {
          var values = _.valuesOfKey(data, dim);
          if (!values.length) {
            values.push(0);
          }
          _.each(values, function (val) {
            if (!map[val]) {
              map[val] = [];
            }
            map[val].push(index);
          });
        });
        cacheMap[dim] = map;
      }
      return map;
    }
  }]);
  return Dodge;
}(Adjust);
export { Dodge as default };