import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as _ from '@antv/util';
import Adjust from './adjust';
var Cache = _.Cache;
var Stack = /*#__PURE__*/function (_Adjust) {
  _inherits(Stack, _Adjust);
  var _super = _createSuper(Stack);
  function Stack(cfg) {
    var _this;
    _classCallCheck(this, Stack);
    _this = _super.call(this, cfg);
    var _cfg$adjustNames = cfg.adjustNames,
      adjustNames = _cfg$adjustNames === void 0 ? ['y'] : _cfg$adjustNames,
      _cfg$height = cfg.height,
      height = _cfg$height === void 0 ? NaN : _cfg$height,
      _cfg$size = cfg.size,
      size = _cfg$size === void 0 ? 10 : _cfg$size,
      _cfg$reverseOrder = cfg.reverseOrder,
      reverseOrder = _cfg$reverseOrder === void 0 ? false : _cfg$reverseOrder;
    _this.adjustNames = adjustNames;
    _this.height = height;
    _this.size = size;
    _this.reverseOrder = reverseOrder;
    return _this;
  }
  /**
   * 方法入参是经过数据分组、数据数字化之后的二维数组
   * @param groupDataArray 分组之后的数据
   */
  _createClass(Stack, [{
    key: "process",
    value: function process(groupDataArray) {
      var yField = this.yField,
        reverseOrder = this.reverseOrder;
      // 如果有指定 y 字段，那么按照 y 字段来 stack
      // 否则，按照高度均分
      var d = yField ? this.processStack(groupDataArray) : this.processOneDimStack(groupDataArray);
      return reverseOrder ? this.reverse(d) : d;
    }
  }, {
    key: "reverse",
    value: function reverse(groupedDataArray) {
      return groupedDataArray.slice(0).reverse();
    }
  }, {
    key: "processStack",
    value: function processStack(groupDataArray) {
      var xField = this.xField,
        yField = this.yField,
        reverseOrder = this.reverseOrder;
      // 层叠顺序翻转
      var groupedDataArray = reverseOrder ? this.reverse(groupDataArray) : groupDataArray;
      // 用来缓存，正数和负数的堆叠问题
      var positive = new Cache();
      var negative = new Cache();
      return groupedDataArray.map(function (dataArray) {
        return dataArray.map(function (data) {
          var x = _.get(data, xField, 0);
          var y = _.get(data, [yField]);
          var xKey = x.toString();
          // todo 是否应该取 _origin？因为 y 可能取到的值不正确，比如先 symmetric，再 stack！
          y = _.isArray(y) ? y[1] : y;
          if (!_.isNil(y)) {
            var cache = y >= 0 ? positive : negative;
            if (!cache.has(xKey)) {
              cache.set(xKey, 0);
            }
            var xValue = cache.get(xKey);
            var newXValue = y + xValue;
            // 存起来
            cache.set(xKey, newXValue);
            return _objectSpread(_objectSpread({}, data), {}, _defineProperty({}, yField, [xValue, newXValue]));
          }
          // 没有修改，则直接返回
          return data;
        });
      });
    }
  }, {
    key: "processOneDimStack",
    value: function processOneDimStack(groupDataArray) {
      var _this2 = this;
      var xField = this.xField,
        height = this.height,
        reverseOrder = this.reverseOrder;
      var yField = 'y';
      // 如果层叠的顺序翻转
      var groupedDataArray = reverseOrder ? this.reverse(groupDataArray) : groupDataArray;
      // 缓存累加数据
      var cache = new Cache();
      return groupedDataArray.map(function (dataArray) {
        return dataArray.map(function (data) {
          var size = _this2.size;
          var xValue = data[xField];
          // todo 没有看到这个 stack 计算原理
          var stackHeight = size * 2 / height;
          if (!cache.has(xValue)) {
            cache.set(xValue, stackHeight / 2); // 初始值大小
          }

          var stackValue = cache.get(xValue);
          // 增加一层 stackHeight
          cache.set(xValue, stackValue + stackHeight);
          return _objectSpread(_objectSpread({}, data), {}, _defineProperty({}, yField, stackValue));
        });
      });
    }
  }]);
  return Stack;
}(Adjust);
export { Stack as default };