import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as _ from '@antv/util';
import Adjust from './adjust';
var Symmetric = /*#__PURE__*/function (_Adjust) {
  _inherits(Symmetric, _Adjust);
  var _super = _createSuper(Symmetric);
  function Symmetric() {
    _classCallCheck(this, Symmetric);
    return _super.apply(this, arguments);
  }
  _createClass(Symmetric, [{
    key: "process",
    value: function process(groupDataArray) {
      var mergeData = _.flatten(groupDataArray);
      var xField = this.xField,
        yField = this.yField;
      // 每个 x 值对应的 最大值
      var cache = this.getXValuesMaxMap(mergeData);
      // 所有数据的最大的值
      var max = Math.max.apply(Math, _toConsumableArray(Object.keys(cache).map(function (key) {
        return cache[key];
      })));
      return _.map(groupDataArray, function (dataArray) {
        return _.map(dataArray, function (data) {
          var yValue = data[yField];
          var xValue = data[xField];
          // 数组处理逻辑
          if (_.isArray(yValue)) {
            var off = (max - cache[xValue]) / 2;
            return _objectSpread(_objectSpread({}, data), {}, _defineProperty({}, yField, _.map(yValue, function (y) {
              return off + y;
            })));
          }
          // 非数组处理逻辑
          var offset = (max - yValue) / 2;
          return _objectSpread(_objectSpread({}, data), {}, _defineProperty({}, yField, [offset, yValue + offset]));
        });
      });
    }
    // 获取每个 x 对应的最大的值
  }, {
    key: "getXValuesMaxMap",
    value: function getXValuesMaxMap(mergeData) {
      var _this = this;
      var xField = this.xField,
        yField = this.yField;
      // 根据 xField 的值进行分组
      var groupDataArray = _.groupBy(mergeData, function (data) {
        return data[xField];
      });
      // 获取每个 xField 值中的最大值
      return _.mapValues(groupDataArray, function (dataArray) {
        return _this.getDimMaxValue(dataArray, yField);
      });
    }
  }, {
    key: "getDimMaxValue",
    value: function getDimMaxValue(mergeData, dim) {
      // 所有的 value 值
      var dimValues = _.map(mergeData, function (data) {
        return _.get(data, dim, []);
      });
      // 将数组打平（dim value 有可能是数组，比如 stack 之后的）
      var flattenValues = _.flatten(dimValues);
      // 求出数组的最大值
      return Math.max.apply(Math, _toConsumableArray(flattenValues));
    }
  }]);
  return Symmetric;
}(Adjust);
export { Symmetric as default };