import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { isNil, isNumber } from '@antv/util';
import Base from '../base';
/**
 * 分类度量
 * @class
 */
var Category = /*#__PURE__*/function (_Base) {
  _inherits(Category, _Base);
  var _super = _createSuper(Category);
  function Category() {
    var _this;
    _classCallCheck(this, Category);
    _this = _super.apply(this, arguments);
    _this.type = 'cat';
    _this.isCategory = true;
    return _this;
  }
  _createClass(Category, [{
    key: "buildIndexMap",
    value: function buildIndexMap() {
      if (!this.translateIndexMap) {
        this.translateIndexMap = new Map();
        // 重新构建缓存
        for (var i = 0; i < this.values.length; i++) {
          this.translateIndexMap.set(this.values[i], i);
        }
      }
    }
  }, {
    key: "translate",
    value: function translate(value) {
      // 按需构建 map
      this.buildIndexMap();
      // 找得到
      var idx = this.translateIndexMap.get(value);
      if (idx === undefined) {
        idx = isNumber(value) ? value : NaN;
      }
      return idx;
    }
  }, {
    key: "scale",
    value: function scale(value) {
      var order = this.translate(value);
      // 分类数据允许 0.5 范围内调整
      // if (order < this.min - 0.5 || order > this.max + 0.5) {
      //   return NaN;
      // }
      var percent = this.calcPercent(order, this.min, this.max);
      return this.calcValue(percent, this.rangeMin(), this.rangeMax());
    }
  }, {
    key: "invert",
    value: function invert(scaledValue) {
      var domainRange = this.max - this.min;
      var percent = this.calcPercent(scaledValue, this.rangeMin(), this.rangeMax());
      var idx = Math.round(domainRange * percent) + this.min;
      if (idx < this.min || idx > this.max) {
        return NaN;
      }
      return this.values[idx];
    }
  }, {
    key: "getText",
    value: function getText(value) {
      var _get2;
      var v = value;
      // value为index
      if (isNumber(value) && !this.values.includes(value)) {
        v = this.values[v];
      }
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      return (_get2 = _get(_getPrototypeOf(Category.prototype), "getText", this)).call.apply(_get2, [this, v].concat(args));
    }
    // 复写属性
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'cat';
    }
    // 设置 min, max
  }, {
    key: "setDomain",
    value: function setDomain() {
      // 用户有可能设置 min
      if (isNil(this.getConfig('min'))) {
        this.min = 0;
      }
      if (isNil(this.getConfig('max'))) {
        var size = this.values.length;
        this.max = size > 1 ? size - 1 : size;
      }
      // scale.init 的时候清除缓存
      if (this.translateIndexMap) {
        this.translateIndexMap = undefined;
      }
    }
  }]);
  return Category;
}(Base);
export default Category;