import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { each, isNumber } from '@antv/util';
import { timeFormat, toTimeStamp } from '../util/time';
import Category from './base';
/**
 * 时间分类度量
 * @class
 */
var TimeCat = /*#__PURE__*/function (_Category) {
  _inherits(TimeCat, _Category);
  var _super = _createSuper(TimeCat);
  function TimeCat() {
    var _this;
    _classCallCheck(this, TimeCat);
    _this = _super.apply(this, arguments);
    _this.type = 'timeCat';
    return _this;
  }
  /**
   * @override
   */
  _createClass(TimeCat, [{
    key: "translate",
    value: function translate(value) {
      value = toTimeStamp(value);
      var index = this.values.indexOf(value);
      if (index === -1) {
        if (isNumber(value) && value < this.values.length) {
          index = value;
        } else {
          index = NaN;
        }
      }
      return index;
    }
    /**
     * 由于时间类型数据需要转换一下，所以复写 getText
     * @override
     */
  }, {
    key: "getText",
    value: function getText(value, tickIndex) {
      var index = this.translate(value);
      if (index > -1) {
        var result = this.values[index];
        var formatter = this.formatter;
        result = formatter ? formatter(result, tickIndex) : timeFormat(result, this.mask);
        return result;
      }
      return value;
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'time-cat';
      this.mask = 'YYYY-MM-DD';
      this.tickCount = 7; // 一般时间数据会显示 7， 14， 30 天的数字
    }
  }, {
    key: "setDomain",
    value: function setDomain() {
      var values = this.values;
      // 针对时间分类类型，会将时间统一转换为时间戳
      each(values, function (v, i) {
        values[i] = toTimeStamp(v);
      });
      values.sort(function (v1, v2) {
        return v1 - v2;
      });
      _get(_getPrototypeOf(TimeCat.prototype), "setDomain", this).call(this);
    }
  }]);
  return TimeCat;
}(Category);
export default TimeCat;