import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { calBase } from '../util/math';
import Continuous from './base';
/**
 * Pow 度量，处理非均匀分布
 */
var Pow = /*#__PURE__*/function (_Continuous) {
  _inherits(Pow, _Continuous);
  var _super = _createSuper(Pow);
  function Pow() {
    var _this;
    _classCallCheck(this, Pow);
    _this = _super.apply(this, arguments);
    _this.type = 'pow';
    return _this;
  }
  /**
   * @override
   */
  _createClass(Pow, [{
    key: "invert",
    value: function invert(value) {
      var percent = this.getInvertPercent(value);
      var exponent = this.exponent;
      var max = calBase(exponent, this.max);
      var min = calBase(exponent, this.min);
      var tmp = percent * (max - min) + min;
      var factor = tmp >= 0 ? 1 : -1;
      return Math.pow(tmp, exponent) * factor;
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'pow';
      this.exponent = 2;
      this.tickCount = 5;
      this.nice = true;
    }
    // 获取度量计算时，value占的定义域百分比
  }, {
    key: "getScalePercent",
    value: function getScalePercent(value) {
      var max = this.max;
      var min = this.min;
      if (max === min) {
        return 0;
      }
      var exponent = this.exponent;
      var percent = (calBase(exponent, value) - calBase(exponent, min)) / (calBase(exponent, max) - calBase(exponent, min));
      return percent;
    }
  }]);
  return Pow;
}(Continuous);
export default Pow;