import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { each, head, last } from '@antv/util';
import Continuous from './base';
/**
 * 分段度量
 */
var Quantize = /*#__PURE__*/function (_Continuous) {
  _inherits(Quantize, _Continuous);
  var _super = _createSuper(Quantize);
  function Quantize() {
    var _this;
    _classCallCheck(this, Quantize);
    _this = _super.apply(this, arguments);
    _this.type = 'quantize';
    return _this;
  }
  _createClass(Quantize, [{
    key: "invert",
    value: function invert(value) {
      var ticks = this.ticks;
      var length = ticks.length;
      var percent = this.getInvertPercent(value);
      var minIndex = Math.floor(percent * (length - 1));
      // 最后一个
      if (minIndex >= length - 1) {
        return last(ticks);
      }
      // 超出左边界， 则取第一个
      if (minIndex < 0) {
        return head(ticks);
      }
      var minTick = ticks[minIndex];
      var nextTick = ticks[minIndex + 1];
      // 比当前值小的 tick 在度量上的占比
      var minIndexPercent = minIndex / (length - 1);
      var maxIndexPercent = (minIndex + 1) / (length - 1);
      return minTick + (percent - minIndexPercent) / (maxIndexPercent - minIndexPercent) * (nextTick - minTick);
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'r-pretty';
      this.tickCount = 5;
      this.nice = true;
    }
  }, {
    key: "calculateTicks",
    value: function calculateTicks() {
      var ticks = _get(_getPrototypeOf(Quantize.prototype), "calculateTicks", this).call(this);
      if (!this.nice) {
        // 如果 nice = false ,补充 min, max
        if (last(ticks) !== this.max) {
          ticks.push(this.max);
        }
        if (head(ticks) !== this.min) {
          ticks.unshift(this.min);
        }
      }
      return ticks;
    }
    // 计算当前值在刻度中的占比
  }, {
    key: "getScalePercent",
    value: function getScalePercent(value) {
      var ticks = this.ticks;
      // 超出左边界
      if (value < head(ticks)) {
        return 0;
      }
      // 超出右边界
      if (value > last(ticks)) {
        return 1;
      }
      var minIndex = 0;
      each(ticks, function (tick, index) {
        if (value >= tick) {
          minIndex = index;
        } else {
          return false;
        }
      });
      return minIndex / (ticks.length - 1);
    }
  }]);
  return Quantize;
}(Continuous);
export default Quantize;