import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { isNumber } from '@antv/util';
import Base from '../base';
/**
 * identity scale原则上是定义域和值域一致，scale/invert方法也是一致的
 * 参考R的实现：https://github.com/r-lib/scales/blob/master/R/pal-identity.r
 * 参考d3的实现（做了下转型）：https://github.com/d3/d3-scale/blob/master/src/identity.js
 */
var Identity = /*#__PURE__*/function (_Base) {
  _inherits(Identity, _Base);
  var _super = _createSuper(Identity);
  function Identity() {
    var _this;
    _classCallCheck(this, Identity);
    _this = _super.apply(this, arguments);
    _this.type = 'identity';
    _this.isIdentity = true;
    return _this;
  }
  _createClass(Identity, [{
    key: "calculateTicks",
    value: function calculateTicks() {
      return this.values;
    }
  }, {
    key: "scale",
    value: function scale(value) {
      // 如果传入的值不等于 identity 的值，则直接返回，用于一维图时的 dodge
      if (this.values[0] !== value && isNumber(value)) {
        return value;
      }
      return this.range[0];
    }
  }, {
    key: "invert",
    value: function invert(value) {
      var range = this.range;
      if (value < range[0] || value > range[1]) {
        return NaN;
      }
      return this.values[0];
    }
  }]);
  return Identity;
}(Base);
export { Identity as default };