import { isNil } from '@antv/util';
/**
 * 按照给定的 minLimit/maxLimit/tickCount 均匀计算出刻度 ticks
 *
 * @param cfg Scale 配置项
 * @return ticks
 */
export default function strictLimit(cfg, defaultMin, defaultMax) {
  var minLimit = cfg.minLimit,
    maxLimit = cfg.maxLimit,
    min = cfg.min,
    max = cfg.max,
    _cfg$tickCount = cfg.tickCount,
    tickCount = _cfg$tickCount === void 0 ? 5 : _cfg$tickCount;
  var tickMin = isNil(minLimit) ? isNil(defaultMin) ? min : defaultMin : minLimit;
  var tickMax = isNil(maxLimit) ? isNil(defaultMax) ? max : defaultMax : maxLimit;
  if (tickMin > tickMax) {
    var _ref = [tickMin, tickMax];
    tickMax = _ref[0];
    tickMin = _ref[1];
  }
  if (tickCount <= 2) {
    return [tickMin, tickMax];
  }
  var step = (tickMax - tickMin) / (tickCount - 1);
  var ticks = [];
  for (var i = 0; i < tickCount; i++) {
    ticks.push(tickMin + step * i);
  }
  return ticks;
}