"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _fEngine = require("@antv/f-engine");
var _util = require("@antv/util");
var _index = require("../index");
var _coord = _interopRequireDefault(require("../controller/coord"));
var _scale = _interopRequireDefault(require("../controller/scale"));
var _theme = _interopRequireDefault(require("../theme"));
// 统计图表
var Chart = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Chart, _Component);
  var _super = (0, _createSuper2.default)(Chart);
  function Chart(props, context) {
    var _this;
    (0, _classCallCheck2.default)(this, Chart);
    _this = _super.call(this, props);
    // 坐标系
    _this.componentsPosition = [];
    var theme = context.theme,
      px2hd = context.px2hd;
    // hack 处理，设置默认的主题样式
    // 目前没想到其他更合适的方式，只能先这样处理
    (0, _util.deepMix)(theme, px2hd(_theme.default));
    var data = props.data;
    _this.scale = new _scale.default(data);
    _this.coord = new _coord.default();
    // state
    _this.state = {
      filters: {}
    };
    return _this;
  }
  (0, _createClass2.default)(Chart, [{
    key: "getStyle",
    value: function getStyle(props) {
      var context = this.context,
        layout = this.layout;
      var theme = context.theme,
        px2hd = context.px2hd;
      var left = layout.left,
        top = layout.top,
        width = layout.width,
        height = layout.height;
      var customStyle = props.style;
      return px2hd((0, _objectSpread3.default)((0, _objectSpread3.default)({
        left: left,
        top: top,
        width: width,
        height: height
      }, theme.chart), customStyle));
    }
  }, {
    key: "willMount",
    value: function willMount() {
      var props = this.props,
        coord = this.coord,
        scale = this.scale;
      var scaleOptions = props.scale,
        coordOption = props.coord;
      var style = this.getStyle(props);
      coord.updateLayout(style);
      // 初始化 scale
      scale.create(scaleOptions);
      // 初始化 coord
      coord.create(coordOption);
    }
    // props 更新
  }, {
    key: "willReceiveProps",
    value: function willReceiveProps(nextProps) {
      var scale = this.scale,
        coord = this.coord,
        lastProps = this.props;
      var nextStyle = nextProps.style,
        nextData = nextProps.data,
        nextScale = nextProps.scale;
      var lastStyle = lastProps.style,
        lastData = lastProps.data,
        lastScale = lastProps.scale;
      // style 更新
      if (!(0, _fEngine.isEqual)(nextStyle, lastStyle)) {
        var style = this.getStyle(nextProps);
        coord.updateLayout(style);
      }
      if (nextData !== lastData) {
        scale.changeData(nextData);
      }
      // scale
      if (!(0, _fEngine.isEqual)(nextScale, lastScale)) {
        scale.update(nextScale);
      }
    }
    // 给需要显示的组件留空
  }, {
    key: "layoutCoord",
    value: function layoutCoord(layout) {
      this.coord.useLayout(layout);
    }
  }, {
    key: "resetCoordLayout",
    value: function resetCoordLayout() {
      var coord = this.coord,
        props = this.props;
      var style = this.getStyle(props);
      coord.updateLayout(style);
    }
  }, {
    key: "updateCoordLayout",
    value: function updateCoordLayout(layout) {
      var _this2 = this;
      if ((0, _util.isArray)(layout)) {
        layout.forEach(function (item) {
          _this2.layoutCoord(item);
        });
        return;
      }
      this.layoutCoord(layout);
    }
  }, {
    key: "updateCoordFor",
    value: function updateCoordFor(component, layout) {
      var _this3 = this;
      if (!layout) return;
      var componentsPosition = this.componentsPosition;
      var componentPosition = {
        component: component,
        layout: layout
      };
      var existIndex = (0, _util.findIndex)(componentsPosition, function (item) {
        return item.component === component;
      });
      // 说明是已经存在的组件
      if (existIndex > -1) {
        componentsPosition.splice(existIndex, 1, componentPosition);
        // 先重置，然后整体重新算一次
        this.resetCoordLayout();
        componentsPosition.forEach(function (componentPosition) {
          var layout = componentPosition.layout;
          _this3.updateCoordLayout(layout);
        });
        return;
      }
      // 是新组件，直接添加
      componentsPosition.push(componentPosition);
      this.updateCoordLayout(layout);
    }
  }, {
    key: "getGeometrys",
    value: function getGeometrys() {
      var children = this.children;
      var geometrys = [];
      // @ts-ignore
      _index.Children.toArray(children).forEach(function (element) {
        if (!element) return false;
        var component = element.component;
        if (component && component.isGeometry) {
          geometrys.push(component);
        }
      });
      return geometrys;
    }
    /**
     * calculate dataset's position on canvas
     * @param  {Object} record the dataset
     * @return {Object} return the position
     */
  }, {
    key: "getPosition",
    value: function getPosition(record) {
      var coord = this.getCoord();
      var xScale = this.getXScales()[0];
      var xField = xScale.field;
      var yScales = this.getYScales();
      // default first
      var yScale = yScales[0];
      var yField = yScale.field;
      for (var i = 0, len = yScales.length; i < len; i++) {
        var scale = yScales[i];
        var field = scale.field;
        if (record[field]) {
          yScale = scale;
          yField = field;
          break;
        }
      }
      var x = xScale.scale(record[xField]);
      var y = yScale.scale(record[yField]);
      return coord.convertPoint({
        x: x,
        y: y
      });
    }
  }, {
    key: "getSnapRecords",
    value: function getSnapRecords(point, inCoordRange) {
      var geometrys = this.getGeometrys();
      if (!geometrys.length) return;
      // @ts-ignore
      return geometrys[0].getSnapRecords(point, inCoordRange);
    }
  }, {
    key: "getLegendItems",
    value: function getLegendItems(point) {
      var geometrys = this.getGeometrys();
      if (!geometrys.length) return;
      // @ts-ignore
      return geometrys[0].getLegendItems(point);
    }
  }, {
    key: "setScale",
    value: function setScale(field, option) {
      this.scale.setScale(field, option);
    }
  }, {
    key: "getScale",
    value: function getScale(field) {
      return this.scale.getScale(field);
    }
  }, {
    key: "getScales",
    value: function getScales() {
      return this.scale.getScales();
    }
  }, {
    key: "getXScales",
    value: function getXScales() {
      var geometrys = this.getGeometrys();
      return geometrys.map(function (component) {
        // @ts-ignore
        return component.getXScale();
      });
    }
  }, {
    key: "getYScales",
    value: function getYScales() {
      var geometrys = this.getGeometrys();
      return geometrys.map(function (component) {
        // @ts-ignore
        return component.getYScale();
      });
    }
  }, {
    key: "getLayout",
    value: function getLayout() {
      return this.coord.layout;
    }
  }, {
    key: "getCoord",
    value: function getCoord() {
      return this.coord.coord;
    }
  }, {
    key: "filter",
    value: function filter(field, condition) {
      var filters = this.state.filters;
      this.setState({
        filters: (0, _objectSpread3.default)((0, _objectSpread3.default)({}, filters), {}, (0, _defineProperty2.default)({}, field, condition))
      });
    }
  }, {
    key: "_getRenderData",
    value: function _getRenderData() {
      var props = this.props,
        state = this.state;
      var data = props.data;
      var filters = state.filters;
      if (!filters || !Object.keys(filters).length) {
        return data;
      }
      var filteredData = data;
      (0, _util.each)(filters, function (condition, field) {
        if (!condition) return;
        filteredData = filteredData.filter(function (record) {
          return condition(record[field], record);
        });
      });
      return filteredData;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      var props = this.props;
      var children = props.children,
        originData = props.data;
      if (!originData) return null;
      var data = this._getRenderData();
      var layout = this.getLayout();
      var coord = this.getCoord();
      return _index.Children.map(children, function (child) {
        return _index.Children.cloneElement(child, {
          chart: _this4,
          layout: layout,
          coord: coord,
          data: data
        });
      });
    }
  }]);
  return Chart;
}(_index.Component);
var _default = Chart;
exports.default = _default;