"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _fEngine = require("@antv/f-engine");
var _util = require("@antv/util");
var _default = function _default(View) {
  return /*#__PURE__*/function (_Component) {
    (0, _inherits2.default)(Legend, _Component);
    var _super = (0, _createSuper2.default)(Legend);
    function Legend(props) {
      var _this;
      (0, _classCallCheck2.default)(this, Legend);
      _this = _super.call(this, props);
      _this._onclick = function (item) {
        var _assertThisInitialize = (0, _assertThisInitialized2.default)(_this),
          props = _assertThisInitialize.props;
        var chart = props.chart,
          _props$clickable = props.clickable,
          clickable = _props$clickable === void 0 ? true : _props$clickable,
          onClick = props.onClick;
        if (!clickable) return;
        var clickItem = item.currentTarget;
        if (!clickItem) {
          return;
        }
        // @ts-ignore
        var dataItem = clickItem.config['data-item'];
        if (!dataItem) {
          return;
        }
        if ((0, _util.isFunction)(onClick)) {
          onClick(dataItem);
        }
        var field = dataItem.field,
          tickValue = dataItem.tickValue;
        var prevFiltered = _this.state.filtered;
        var filtered = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, prevFiltered), {}, (0, _defineProperty2.default)({}, tickValue, !prevFiltered[tickValue]));
        _this.setState({
          filtered: filtered
        });
        chart.filter(field, function (value) {
          return !filtered[value];
        });
      };
      _this.state = {
        filtered: {},
        items: []
      };
      return _this;
    }
    (0, _createClass2.default)(Legend, [{
      key: "getOriginItems",
      value: function getOriginItems() {
        var chart = this.props.chart;
        return chart.getLegendItems();
      }
    }, {
      key: "getItems",
      value: function getItems() {
        var _props$items;
        var props = this.props,
          state = this.state;
        var filtered = state.filtered;
        var renderItems = ((_props$items = props.items) === null || _props$items === void 0 ? void 0 : _props$items.length) ? props.items : this.getOriginItems();
        if (!renderItems) return null;
        return renderItems.map(function (item) {
          var tickValue = item.tickValue;
          return (0, _objectSpread3.default)((0, _objectSpread3.default)({}, item), {}, {
            filtered: filtered[tickValue]
          });
        });
      }
    }, {
      key: "setItems",
      value: function setItems(items) {
        this.setState({
          items: items
        });
      }
    }, {
      key: "getMaxItemBox",
      value: function getMaxItemBox(node) {
        var maxItemWidth = 0;
        var maxItemHeight = 0;
        (node.children || []).forEach(function (child) {
          var layout = child.layout;
          var width = layout.width,
            height = layout.height;
          maxItemWidth = Math.max(maxItemWidth, width);
          maxItemHeight = Math.max(maxItemHeight, height);
        });
        return {
          width: maxItemWidth,
          height: maxItemHeight
        };
      }
      // 计算 legend 的位置
    }, {
      key: "_init",
      value: function _init() {
        var props = this.props,
          context = this.context;
        var parentLayout = props.layout,
          customWidth = props.width,
          customHeight = props.height,
          _props$position = props.position,
          position = _props$position === void 0 ? 'top' : _props$position;
        var items = this.getItems();
        if (!items || !items.length) return;
        var left = parentLayout.left,
          top = parentLayout.top,
          layoutWidth = parentLayout.width,
          layoutHeight = parentLayout.height;
        var width = context.px2hd(customWidth) || layoutWidth;
        var node = (0, _fEngine.computeLayout)(this, this.render());
        var _this$getMaxItemBox = this.getMaxItemBox(node),
          itemMaxWidth = _this$getMaxItemBox.width,
          itemMaxHeight = _this$getMaxItemBox.height;
        // 每行最多的个数
        var lineMaxCount = Math.max(1, Math.floor(width / itemMaxWidth));
        var itemCount = items.length;
        // legend item 的行数
        var lineCount = Math.ceil(itemCount / lineMaxCount);
        var itemWidth = width / lineMaxCount;
        var autoHeight = itemMaxHeight * lineCount;
        var style = {
          left: left,
          top: top,
          width: width,
          // height 默认自适应
          height: undefined,
          flexDirection: 'row',
          flexWrap: 'wrap',
          alignItems: 'center',
          justifyContent: 'flex-start'
        };
        // 如果只有一行，2端对齐
        if (lineCount === 1) {
          style.justifyContent = 'space-between';
        }
        if (position === 'top') {
          style.height = customHeight ? customHeight : autoHeight;
        }
        if (position === 'left') {
          style.flexDirection = 'column';
          style.justifyContent = 'center';
          style.width = itemMaxWidth;
          style.height = customHeight ? customHeight : layoutHeight;
        }
        if (position === 'right') {
          style.flexDirection = 'column';
          style.alignItems = 'flex-start';
          style.justifyContent = 'center';
          style.width = itemMaxWidth;
          style.height = customHeight ? customHeight : layoutHeight;
          style.left = left + (width - itemMaxWidth);
        }
        if (position === 'bottom') {
          style.top = top + (layoutHeight - autoHeight);
          style.height = customHeight ? customHeight : autoHeight;
        }
        this.itemWidth = itemWidth;
        this.legendStyle = style;
      }
    }, {
      key: "updateCoord",
      value: function updateCoord() {
        var context = this.context,
          props = this.props,
          legendStyle = this.legendStyle;
        var _props$position2 = props.position,
          position = _props$position2 === void 0 ? 'top' : _props$position2,
          _props$margin = props.margin,
          margin = _props$margin === void 0 ? '30px' : _props$margin,
          chart = props.chart;
        var width = legendStyle.width,
          height = legendStyle.height;
        var marginNumber = context.px2hd(margin);
        chart.updateCoordFor(this, {
          position: position,
          width: width + marginNumber,
          height: height + marginNumber
        });
      }
    }, {
      key: "willMount",
      value: function willMount() {
        var items = this.getItems();
        if (!items || !items.length) return;
        this._init();
        this.updateCoord();
      }
    }, {
      key: "didMount",
      value: function didMount() {
        // this._initEvent();
      }
    }, {
      key: "willUpdate",
      value: function willUpdate() {
        var items = this.getItems();
        if (!items || !items.length) return;
        this.updateCoord();
      }
    }, {
      key: "render",
      value: function render() {
        var props = this.props,
          itemWidth = this.itemWidth,
          legendStyle = this.legendStyle;
        var items = this.getItems();
        if (!items || !items.length) {
          return null;
        }
        return (0, _fEngine.jsx)(View, (0, _objectSpread3.default)((0, _objectSpread3.default)({}, props), {}, {
          items: items,
          itemWidth: itemWidth,
          style: (0, _objectSpread3.default)((0, _objectSpread3.default)({}, legendStyle), props.style),
          onClick: this._onclick
        }));
      }
    }]);
    return Legend;
  }(_fEngine.Component);
};
exports.default = _default;