"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Coord", {
  enumerable: true,
  get: function get() {
    return _coord.default;
  }
});
exports.default = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _coord = _interopRequireWildcard(require("../coord"));
var _util = require("@antv/util");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var coordMap = {
  rect: _coord.Rect,
  polar: _coord.Polar
};
var coordController = /*#__PURE__*/function () {
  function coordController() {
    (0, _classCallCheck2.default)(this, coordController);
  }
  (0, _createClass2.default)(coordController, [{
    key: "getOption",
    value: function getOption(cfg) {
      if ((0, _util.isString)(cfg)) {
        return {
          type: coordMap[cfg] || _coord.Rect
        };
      }
      if ((0, _util.isFunction)(cfg)) {
        return {
          type: cfg
        };
      }
      var _ref = cfg || {},
        type = _ref.type;
      return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, cfg), {}, {
        // 默认直角坐标系
        type: (0, _util.isFunction)(type) ? type : coordMap[type] || _coord.Rect
      });
    }
  }, {
    key: "create",
    value: function create(cfg) {
      var layout = this.layout;
      var option = this.getOption(cfg);
      var type = option.type;
      var coord = new type((0, _objectSpread2.default)((0, _objectSpread2.default)({}, option), layout));
      this.coord = coord;
      return coord;
    }
  }, {
    key: "updateLayout",
    value: function updateLayout(style) {
      var coord = this.coord;
      var left = style.left,
        top = style.top,
        width = style.width,
        height = style.height,
        padding = style.padding;
      var _ref2 = padding || [0, 0, 0, 0],
        _ref3 = (0, _slicedToArray2.default)(_ref2, 4),
        paddingTop = _ref3[0],
        paddingRight = _ref3[1],
        paddingBottom = _ref3[2],
        paddingLeft = _ref3[3];
      this.layout = {
        left: left + paddingLeft,
        top: top + paddingTop,
        width: width - paddingLeft - paddingRight,
        height: height - paddingTop - paddingBottom
      };
      if (coord) {
        coord.update(this.layout);
      }
    }
  }, {
    key: "useLayout",
    value: function useLayout(positionLayout) {
      var coord = this.coord;
      var position = positionLayout.position,
        boxWidth = positionLayout.width,
        boxHeight = positionLayout.height;
      var left = coord.left,
        top = coord.top,
        width = coord.width,
        height = coord.height;
      switch (position) {
        case 'left':
          left += boxWidth;
          width = Math.max(0, width - boxWidth);
          break;
        case 'right':
          width = Math.max(0, width - boxWidth);
          break;
        case 'top':
          top += boxHeight;
          height = Math.max(0, height - boxHeight);
          break;
        case 'bottom':
          height = Math.max(0, height - boxHeight);
          break;
      }
      coord.update({
        left: left,
        top: top,
        width: width,
        height: height
      });
    }
  }, {
    key: "update",
    value: function update() {}
  }, {
    key: "getCoord",
    value: function getCoord() {
      return this.coord;
    }
  }]);
  return coordController;
}();
var _default = coordController;
exports.default = _default;