"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _ = _interopRequireWildcard(require("@antv/util"));
var _constant = require("../constant");
var _adjust = _interopRequireDefault(require("./adjust"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function randomNumber(min, max) {
  return (max - min) * Math.random() + min;
}
var Jitter = /*#__PURE__*/function (_Adjust) {
  (0, _inherits2.default)(Jitter, _Adjust);
  var _super = (0, _createSuper2.default)(Jitter);
  function Jitter() {
    (0, _classCallCheck2.default)(this, Jitter);
    return _super.apply(this, arguments);
  }
  (0, _createClass2.default)(Jitter, [{
    key: "process",
    value: function process(groupDataArray) {
      var groupedDataArray = _.clone(groupDataArray);
      // 之前分组之后的数据，然后有合并回去（和分组前可以理解成是一样的）
      var mergeData = _.flatten(groupedDataArray);
      // 返回值
      this.adjustData(groupedDataArray, mergeData);
      return groupedDataArray;
    }
    /**
     * 当前数据分组（index）中，按照维度 dim 进行 jitter 调整
     * @param dim
     * @param values
     * @param dataArray
     */
  }, {
    key: "adjustDim",
    value: function adjustDim(dim, values, dataArray) {
      var _this = this;
      // 在每一个分组中，将数据再按照 dim 分组，用于散列
      var groupDataArray = this.groupData(dataArray, dim);
      return _.each(groupDataArray, function (data, dimValue) {
        return _this.adjustGroup(data, dim, parseFloat(dimValue), values);
      });
    }
    // 随机出来的字段值
  }, {
    key: "getAdjustOffset",
    value: function getAdjustOffset(range) {
      var pre = range.pre,
        next = range.next;
      // 随机的范围
      var margin = (next - pre) * _constant.GAP;
      return randomNumber(pre + margin, next - margin);
    }
    // adjust group data
  }, {
    key: "adjustGroup",
    value: function adjustGroup(group, dim, dimValue, values) {
      var _this2 = this;
      // 调整范围
      var range = this.getAdjustRange(dim, dimValue, values);
      _.each(group, function (data) {
        data[dim] = _this2.getAdjustOffset(range); // 获取调整的位置
      });

      return group;
    }
  }]);
  return Jitter;
}(_adjust.default);
exports.default = Jitter;