"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectSpread4 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _ = _interopRequireWildcard(require("@antv/util"));
var _adjust = _interopRequireDefault(require("./adjust"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var Cache = _.Cache;
var Stack = /*#__PURE__*/function (_Adjust) {
  (0, _inherits2.default)(Stack, _Adjust);
  var _super = (0, _createSuper2.default)(Stack);
  function Stack(cfg) {
    var _this;
    (0, _classCallCheck2.default)(this, Stack);
    _this = _super.call(this, cfg);
    var _cfg$adjustNames = cfg.adjustNames,
      adjustNames = _cfg$adjustNames === void 0 ? ['y'] : _cfg$adjustNames,
      _cfg$height = cfg.height,
      height = _cfg$height === void 0 ? NaN : _cfg$height,
      _cfg$size = cfg.size,
      size = _cfg$size === void 0 ? 10 : _cfg$size,
      _cfg$reverseOrder = cfg.reverseOrder,
      reverseOrder = _cfg$reverseOrder === void 0 ? false : _cfg$reverseOrder;
    _this.adjustNames = adjustNames;
    _this.height = height;
    _this.size = size;
    _this.reverseOrder = reverseOrder;
    return _this;
  }
  /**
   * 方法入参是经过数据分组、数据数字化之后的二维数组
   * @param groupDataArray 分组之后的数据
   */
  (0, _createClass2.default)(Stack, [{
    key: "process",
    value: function process(groupDataArray) {
      var yField = this.yField,
        reverseOrder = this.reverseOrder;
      // 如果有指定 y 字段，那么按照 y 字段来 stack
      // 否则，按照高度均分
      var d = yField ? this.processStack(groupDataArray) : this.processOneDimStack(groupDataArray);
      return reverseOrder ? this.reverse(d) : d;
    }
  }, {
    key: "reverse",
    value: function reverse(groupedDataArray) {
      return groupedDataArray.slice(0).reverse();
    }
  }, {
    key: "processStack",
    value: function processStack(groupDataArray) {
      var xField = this.xField,
        yField = this.yField,
        reverseOrder = this.reverseOrder;
      // 层叠顺序翻转
      var groupedDataArray = reverseOrder ? this.reverse(groupDataArray) : groupDataArray;
      // 用来缓存，正数和负数的堆叠问题
      var positive = new Cache();
      var negative = new Cache();
      return groupedDataArray.map(function (dataArray) {
        return dataArray.map(function (data) {
          var x = _.get(data, xField, 0);
          var y = _.get(data, [yField]);
          var xKey = x.toString();
          // todo 是否应该取 _origin？因为 y 可能取到的值不正确，比如先 symmetric，再 stack！
          y = _.isArray(y) ? y[1] : y;
          if (!_.isNil(y)) {
            var cache = y >= 0 ? positive : negative;
            if (!cache.has(xKey)) {
              cache.set(xKey, 0);
            }
            var xValue = cache.get(xKey);
            var newXValue = y + xValue;
            // 存起来
            cache.set(xKey, newXValue);
            return (0, _objectSpread4.default)((0, _objectSpread4.default)({}, data), {}, (0, _defineProperty2.default)({}, yField, [xValue, newXValue]));
          }
          // 没有修改，则直接返回
          return data;
        });
      });
    }
  }, {
    key: "processOneDimStack",
    value: function processOneDimStack(groupDataArray) {
      var _this2 = this;
      var xField = this.xField,
        height = this.height,
        reverseOrder = this.reverseOrder;
      var yField = 'y';
      // 如果层叠的顺序翻转
      var groupedDataArray = reverseOrder ? this.reverse(groupDataArray) : groupDataArray;
      // 缓存累加数据
      var cache = new Cache();
      return groupedDataArray.map(function (dataArray) {
        return dataArray.map(function (data) {
          var size = _this2.size;
          var xValue = data[xField];
          // todo 没有看到这个 stack 计算原理
          var stackHeight = size * 2 / height;
          if (!cache.has(xValue)) {
            cache.set(xValue, stackHeight / 2); // 初始值大小
          }

          var stackValue = cache.get(xValue);
          // 增加一层 stackHeight
          cache.set(xValue, stackValue + stackHeight);
          return (0, _objectSpread4.default)((0, _objectSpread4.default)({}, data), {}, (0, _defineProperty2.default)({}, yField, stackValue));
        });
      });
    }
  }]);
  return Stack;
}(_adjust.default);
exports.default = Stack;