"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectSpread4 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _ = _interopRequireWildcard(require("@antv/util"));
var _adjust = _interopRequireDefault(require("./adjust"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var Symmetric = /*#__PURE__*/function (_Adjust) {
  (0, _inherits2.default)(Symmetric, _Adjust);
  var _super = (0, _createSuper2.default)(Symmetric);
  function Symmetric() {
    (0, _classCallCheck2.default)(this, Symmetric);
    return _super.apply(this, arguments);
  }
  (0, _createClass2.default)(Symmetric, [{
    key: "process",
    value: function process(groupDataArray) {
      var mergeData = _.flatten(groupDataArray);
      var xField = this.xField,
        yField = this.yField;
      // 每个 x 值对应的 最大值
      var cache = this.getXValuesMaxMap(mergeData);
      // 所有数据的最大的值
      var max = Math.max.apply(Math, (0, _toConsumableArray2.default)(Object.keys(cache).map(function (key) {
        return cache[key];
      })));
      return _.map(groupDataArray, function (dataArray) {
        return _.map(dataArray, function (data) {
          var yValue = data[yField];
          var xValue = data[xField];
          // 数组处理逻辑
          if (_.isArray(yValue)) {
            var off = (max - cache[xValue]) / 2;
            return (0, _objectSpread4.default)((0, _objectSpread4.default)({}, data), {}, (0, _defineProperty2.default)({}, yField, _.map(yValue, function (y) {
              return off + y;
            })));
          }
          // 非数组处理逻辑
          var offset = (max - yValue) / 2;
          return (0, _objectSpread4.default)((0, _objectSpread4.default)({}, data), {}, (0, _defineProperty2.default)({}, yField, [offset, yValue + offset]));
        });
      });
    }
    // 获取每个 x 对应的最大的值
  }, {
    key: "getXValuesMaxMap",
    value: function getXValuesMaxMap(mergeData) {
      var _this = this;
      var xField = this.xField,
        yField = this.yField;
      // 根据 xField 的值进行分组
      var groupDataArray = _.groupBy(mergeData, function (data) {
        return data[xField];
      });
      // 获取每个 xField 值中的最大值
      return _.mapValues(groupDataArray, function (dataArray) {
        return _this.getDimMaxValue(dataArray, yField);
      });
    }
  }, {
    key: "getDimMaxValue",
    value: function getDimMaxValue(mergeData, dim) {
      // 所有的 value 值
      var dimValues = _.map(mergeData, function (data) {
        return _.get(data, dim, []);
      });
      // 将数组打平（dim value 有可能是数组，比如 stack 之后的）
      var flattenValues = _.flatten(dimValues);
      // 求出数组的最大值
      return Math.max.apply(Math, (0, _toConsumableArray2.default)(flattenValues));
    }
  }]);
  return Symmetric;
}(_adjust.default);
exports.default = Symmetric;