"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get3 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _util = require("@antv/util");
var _base = _interopRequireDefault(require("../base"));
/**
 * 分类度量
 * @class
 */
var Category = /*#__PURE__*/function (_Base) {
  (0, _inherits2.default)(Category, _Base);
  var _super = (0, _createSuper2.default)(Category);
  function Category() {
    var _this;
    (0, _classCallCheck2.default)(this, Category);
    _this = _super.apply(this, arguments);
    _this.type = 'cat';
    _this.isCategory = true;
    return _this;
  }
  (0, _createClass2.default)(Category, [{
    key: "buildIndexMap",
    value: function buildIndexMap() {
      if (!this.translateIndexMap) {
        this.translateIndexMap = new Map();
        // 重新构建缓存
        for (var i = 0; i < this.values.length; i++) {
          this.translateIndexMap.set(this.values[i], i);
        }
      }
    }
  }, {
    key: "translate",
    value: function translate(value) {
      // 按需构建 map
      this.buildIndexMap();
      // 找得到
      var idx = this.translateIndexMap.get(value);
      if (idx === undefined) {
        idx = (0, _util.isNumber)(value) ? value : NaN;
      }
      return idx;
    }
  }, {
    key: "scale",
    value: function scale(value) {
      var order = this.translate(value);
      // 分类数据允许 0.5 范围内调整
      // if (order < this.min - 0.5 || order > this.max + 0.5) {
      //   return NaN;
      // }
      var percent = this.calcPercent(order, this.min, this.max);
      return this.calcValue(percent, this.rangeMin(), this.rangeMax());
    }
  }, {
    key: "invert",
    value: function invert(scaledValue) {
      var domainRange = this.max - this.min;
      var percent = this.calcPercent(scaledValue, this.rangeMin(), this.rangeMax());
      var idx = Math.round(domainRange * percent) + this.min;
      if (idx < this.min || idx > this.max) {
        return NaN;
      }
      return this.values[idx];
    }
  }, {
    key: "getText",
    value: function getText(value) {
      var _get2;
      var v = value;
      // value为index
      if ((0, _util.isNumber)(value) && !this.values.includes(value)) {
        v = this.values[v];
      }
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      return (_get2 = (0, _get3.default)((0, _getPrototypeOf2.default)(Category.prototype), "getText", this)).call.apply(_get2, [this, v].concat(args));
    }
    // 复写属性
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'cat';
    }
    // 设置 min, max
  }, {
    key: "setDomain",
    value: function setDomain() {
      // 用户有可能设置 min
      if ((0, _util.isNil)(this.getConfig('min'))) {
        this.min = 0;
      }
      if ((0, _util.isNil)(this.getConfig('max'))) {
        var size = this.values.length;
        this.max = size > 1 ? size - 1 : size;
      }
      // scale.init 的时候清除缓存
      if (this.translateIndexMap) {
        this.translateIndexMap = undefined;
      }
    }
  }]);
  return Category;
}(_base.default);
var _default = Category;
exports.default = _default;