"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _util = require("@antv/util");
var _time = require("../util/time");
var _base = _interopRequireDefault(require("./base"));
/**
 * 时间分类度量
 * @class
 */
var TimeCat = /*#__PURE__*/function (_Category) {
  (0, _inherits2.default)(TimeCat, _Category);
  var _super = (0, _createSuper2.default)(TimeCat);
  function TimeCat() {
    var _this;
    (0, _classCallCheck2.default)(this, TimeCat);
    _this = _super.apply(this, arguments);
    _this.type = 'timeCat';
    return _this;
  }
  /**
   * @override
   */
  (0, _createClass2.default)(TimeCat, [{
    key: "translate",
    value: function translate(value) {
      value = (0, _time.toTimeStamp)(value);
      var index = this.values.indexOf(value);
      if (index === -1) {
        if ((0, _util.isNumber)(value) && value < this.values.length) {
          index = value;
        } else {
          index = NaN;
        }
      }
      return index;
    }
    /**
     * 由于时间类型数据需要转换一下，所以复写 getText
     * @override
     */
  }, {
    key: "getText",
    value: function getText(value, tickIndex) {
      var index = this.translate(value);
      if (index > -1) {
        var result = this.values[index];
        var formatter = this.formatter;
        result = formatter ? formatter(result, tickIndex) : (0, _time.timeFormat)(result, this.mask);
        return result;
      }
      return value;
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'time-cat';
      this.mask = 'YYYY-MM-DD';
      this.tickCount = 7; // 一般时间数据会显示 7， 14， 30 天的数字
    }
  }, {
    key: "setDomain",
    value: function setDomain() {
      var values = this.values;
      // 针对时间分类类型，会将时间统一转换为时间戳
      (0, _util.each)(values, function (v, i) {
        values[i] = (0, _time.toTimeStamp)(v);
      });
      values.sort(function (v1, v2) {
        return v1 - v2;
      });
      (0, _get2.default)((0, _getPrototypeOf2.default)(TimeCat.prototype), "setDomain", this).call(this);
    }
  }]);
  return TimeCat;
}(_base.default);
var _default = TimeCat;
exports.default = _default;