"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _util = require("@antv/util");
var _base = _interopRequireDefault(require("../base"));
/**
 * 连续度量的基类
 * @class
 */
var Continuous = /*#__PURE__*/function (_Base) {
  (0, _inherits2.default)(Continuous, _Base);
  var _super = (0, _createSuper2.default)(Continuous);
  function Continuous() {
    var _this;
    (0, _classCallCheck2.default)(this, Continuous);
    _this = _super.apply(this, arguments);
    _this.isContinuous = true;
    return _this;
  }
  (0, _createClass2.default)(Continuous, [{
    key: "scale",
    value: function scale(value) {
      if ((0, _util.isNil)(value)) {
        return NaN;
      }
      var rangeMin = this.rangeMin();
      var rangeMax = this.rangeMax();
      var max = this.max;
      var min = this.min;
      if (max === min) {
        return rangeMin;
      }
      var percent = this.getScalePercent(value);
      return rangeMin + percent * (rangeMax - rangeMin);
    }
  }, {
    key: "init",
    value: function init() {
      (0, _get2.default)((0, _getPrototypeOf2.default)(Continuous.prototype), "init", this).call(this);
      // init 完成后保证 min, max 包含 ticks 的范围
      var ticks = this.ticks;
      var firstTick = (0, _util.head)(ticks);
      var lastTick = (0, _util.last)(ticks);
      if (firstTick < this.min) {
        this.min = firstTick;
      }
      if (lastTick > this.max) {
        this.max = lastTick;
      }
      // strict-limit 方式
      if (!(0, _util.isNil)(this.minLimit)) {
        this.min = firstTick;
      }
      if (!(0, _util.isNil)(this.maxLimit)) {
        this.max = lastTick;
      }
    }
  }, {
    key: "setDomain",
    value: function setDomain() {
      var _getRange = (0, _util.getRange)(this.values),
        min = _getRange.min,
        max = _getRange.max;
      if ((0, _util.isNil)(this.min)) {
        this.min = min;
      }
      if ((0, _util.isNil)(this.max)) {
        this.max = max;
      }
      if (this.min > this.max) {
        this.min = min;
        this.max = max;
      }
    }
  }, {
    key: "calculateTicks",
    value: function calculateTicks() {
      var _this2 = this;
      var ticks = (0, _get2.default)((0, _getPrototypeOf2.default)(Continuous.prototype), "calculateTicks", this).call(this);
      if (!this.nice) {
        ticks = (0, _util.filter)(ticks, function (tick) {
          return tick >= _this2.min && tick <= _this2.max;
        });
      }
      return ticks;
    }
    // 计算原始值值占的百分比
  }, {
    key: "getScalePercent",
    value: function getScalePercent(value) {
      var max = this.max;
      var min = this.min;
      return (value - min) / (max - min);
    }
  }, {
    key: "getInvertPercent",
    value: function getInvertPercent(value) {
      return (value - this.rangeMin()) / (this.rangeMax() - this.rangeMin());
    }
  }]);
  return Continuous;
}(_base.default);
exports.default = Continuous;