"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _math = require("../util/math");
var _base = _interopRequireDefault(require("./base"));
/**
 * Pow 度量，处理非均匀分布
 */
var Pow = /*#__PURE__*/function (_Continuous) {
  (0, _inherits2.default)(Pow, _Continuous);
  var _super = (0, _createSuper2.default)(Pow);
  function Pow() {
    var _this;
    (0, _classCallCheck2.default)(this, Pow);
    _this = _super.apply(this, arguments);
    _this.type = 'pow';
    return _this;
  }
  /**
   * @override
   */
  (0, _createClass2.default)(Pow, [{
    key: "invert",
    value: function invert(value) {
      var percent = this.getInvertPercent(value);
      var exponent = this.exponent;
      var max = (0, _math.calBase)(exponent, this.max);
      var min = (0, _math.calBase)(exponent, this.min);
      var tmp = percent * (max - min) + min;
      var factor = tmp >= 0 ? 1 : -1;
      return Math.pow(tmp, exponent) * factor;
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'pow';
      this.exponent = 2;
      this.tickCount = 5;
      this.nice = true;
    }
    // 获取度量计算时，value占的定义域百分比
  }, {
    key: "getScalePercent",
    value: function getScalePercent(value) {
      var max = this.max;
      var min = this.min;
      if (max === min) {
        return 0;
      }
      var exponent = this.exponent;
      var percent = ((0, _math.calBase)(exponent, value) - (0, _math.calBase)(exponent, min)) / ((0, _math.calBase)(exponent, max) - (0, _math.calBase)(exponent, min));
      return percent;
    }
  }]);
  return Pow;
}(_base.default);
var _default = Pow;
exports.default = _default;