"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _util = require("@antv/util");
var _base = _interopRequireDefault(require("./base"));
/**
 * 分段度量
 */
var Quantize = /*#__PURE__*/function (_Continuous) {
  (0, _inherits2.default)(Quantize, _Continuous);
  var _super = (0, _createSuper2.default)(Quantize);
  function Quantize() {
    var _this;
    (0, _classCallCheck2.default)(this, Quantize);
    _this = _super.apply(this, arguments);
    _this.type = 'quantize';
    return _this;
  }
  (0, _createClass2.default)(Quantize, [{
    key: "invert",
    value: function invert(value) {
      var ticks = this.ticks;
      var length = ticks.length;
      var percent = this.getInvertPercent(value);
      var minIndex = Math.floor(percent * (length - 1));
      // 最后一个
      if (minIndex >= length - 1) {
        return (0, _util.last)(ticks);
      }
      // 超出左边界， 则取第一个
      if (minIndex < 0) {
        return (0, _util.head)(ticks);
      }
      var minTick = ticks[minIndex];
      var nextTick = ticks[minIndex + 1];
      // 比当前值小的 tick 在度量上的占比
      var minIndexPercent = minIndex / (length - 1);
      var maxIndexPercent = (minIndex + 1) / (length - 1);
      return minTick + (percent - minIndexPercent) / (maxIndexPercent - minIndexPercent) * (nextTick - minTick);
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'r-pretty';
      this.tickCount = 5;
      this.nice = true;
    }
  }, {
    key: "calculateTicks",
    value: function calculateTicks() {
      var ticks = (0, _get2.default)((0, _getPrototypeOf2.default)(Quantize.prototype), "calculateTicks", this).call(this);
      if (!this.nice) {
        // 如果 nice = false ,补充 min, max
        if ((0, _util.last)(ticks) !== this.max) {
          ticks.push(this.max);
        }
        if ((0, _util.head)(ticks) !== this.min) {
          ticks.unshift(this.min);
        }
      }
      return ticks;
    }
    // 计算当前值在刻度中的占比
  }, {
    key: "getScalePercent",
    value: function getScalePercent(value) {
      var ticks = this.ticks;
      // 超出左边界
      if (value < (0, _util.head)(ticks)) {
        return 0;
      }
      // 超出右边界
      if (value > (0, _util.last)(ticks)) {
        return 1;
      }
      var minIndex = 0;
      (0, _util.each)(ticks, function (tick, index) {
        if (value >= tick) {
          minIndex = index;
        } else {
          return false;
        }
      });
      return minIndex / (ticks.length - 1);
    }
  }]);
  return Quantize;
}(_base.default);
var _default = Quantize;
exports.default = _default;