"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _util = require("@antv/util");
var _time = require("../util/time");
var _linear = _interopRequireDefault(require("./linear"));
/**
 * 时间度量
 * @class
 */
var Time = /*#__PURE__*/function (_Linear) {
  (0, _inherits2.default)(Time, _Linear);
  var _super = (0, _createSuper2.default)(Time);
  function Time() {
    var _this;
    (0, _classCallCheck2.default)(this, Time);
    _this = _super.apply(this, arguments);
    _this.type = 'time';
    return _this;
  }
  /**
   * @override
   */
  (0, _createClass2.default)(Time, [{
    key: "getText",
    value: function getText(value, index) {
      var numberValue = this.translate(value);
      var formatter = this.formatter;
      return formatter ? formatter(numberValue, index) : (0, _time.timeFormat)(numberValue, this.mask);
    }
    /**
     * @override
     */
  }, {
    key: "scale",
    value: function scale(value) {
      var v = value;
      if ((0, _util.isString)(v) || (0, _util.isDate)(v)) {
        v = this.translate(v);
      }
      return (0, _get2.default)((0, _getPrototypeOf2.default)(Time.prototype), "scale", this).call(this, v);
    }
    /**
     * 将时间转换成数字
     * @override
     */
  }, {
    key: "translate",
    value: function translate(v) {
      return (0, _time.toTimeStamp)(v);
    }
  }, {
    key: "initCfg",
    value: function initCfg() {
      this.tickMethod = 'time-pretty';
      this.mask = 'YYYY-MM-DD';
      this.tickCount = 7;
      this.nice = false;
    }
  }, {
    key: "setDomain",
    value: function setDomain() {
      var values = this.values;
      // 是否设置了 min, max，而不是直接取 this.min, this.max
      var minConfig = this.getConfig('min');
      var maxConfig = this.getConfig('max');
      // 如果设置了 min,max 则转换成时间戳
      if (!(0, _util.isNil)(minConfig) || !(0, _util.isNumber)(minConfig)) {
        this.min = this.translate(this.min);
      }
      if (!(0, _util.isNil)(maxConfig) || !(0, _util.isNumber)(maxConfig)) {
        this.max = this.translate(this.max);
      }
      // 没有设置 min, max 时
      if (values && values.length) {
        // 重新计算最大最小值
        var timeStamps = [];
        var min = Infinity; // 最小值
        var secondMin = min; // 次小值
        var max = 0;
        // 使用一个循环，计算min,max,secondMin
        (0, _util.each)(values, function (v) {
          var timeStamp = (0, _time.toTimeStamp)(v);
          if (isNaN(timeStamp)) {
            throw new TypeError("Invalid Time: ".concat(v, " in time scale!"));
          }
          if (min > timeStamp) {
            secondMin = min;
            min = timeStamp;
          } else if (secondMin > timeStamp) {
            secondMin = timeStamp;
          }
          if (max < timeStamp) {
            max = timeStamp;
          }
          timeStamps.push(timeStamp);
        });
        // 存在多个值时，设置最小间距
        if (values.length > 1) {
          this.minTickInterval = secondMin - min;
        }
        if ((0, _util.isNil)(minConfig)) {
          this.min = min;
        }
        if ((0, _util.isNil)(maxConfig)) {
          this.max = max;
        }
      }
    }
  }]);
  return Time;
}(_linear.default);
var _default = Time;
exports.default = _default;