"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _util = require("@antv/util");
var _base = _interopRequireDefault(require("../base"));
/**
 * identity scale原则上是定义域和值域一致，scale/invert方法也是一致的
 * 参考R的实现：https://github.com/r-lib/scales/blob/master/R/pal-identity.r
 * 参考d3的实现（做了下转型）：https://github.com/d3/d3-scale/blob/master/src/identity.js
 */
var Identity = /*#__PURE__*/function (_Base) {
  (0, _inherits2.default)(Identity, _Base);
  var _super = (0, _createSuper2.default)(Identity);
  function Identity() {
    var _this;
    (0, _classCallCheck2.default)(this, Identity);
    _this = _super.apply(this, arguments);
    _this.type = 'identity';
    _this.isIdentity = true;
    return _this;
  }
  (0, _createClass2.default)(Identity, [{
    key: "calculateTicks",
    value: function calculateTicks() {
      return this.values;
    }
  }, {
    key: "scale",
    value: function scale(value) {
      // 如果传入的值不等于 identity 的值，则直接返回，用于一维图时的 dodge
      if (this.values[0] !== value && (0, _util.isNumber)(value)) {
        return value;
      }
      return this.range[0];
    }
  }, {
    key: "invert",
    value: function invert(value) {
      var range = this.range;
      if (value < range[0] || value > range[1]) {
        return NaN;
      }
      return this.values[0];
    }
  }]);
  return Identity;
}(_base.default);
exports.default = Identity;