"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = d3LinearTickMethod;
var _util = require("@antv/util");
var _d3Linear = _interopRequireDefault(require("../util/d3-linear"));
var _interval = _interopRequireDefault(require("../util/interval"));
var _strictLimit = _interopRequireDefault(require("../util/strict-limit"));
function d3LinearTickMethod(cfg) {
  var min = cfg.min,
    max = cfg.max,
    tickInterval = cfg.tickInterval,
    minLimit = cfg.minLimit,
    maxLimit = cfg.maxLimit;
  var ticks = (0, _d3Linear.default)(cfg);
  if (!(0, _util.isNil)(minLimit) || !(0, _util.isNil)(maxLimit)) {
    return (0, _strictLimit.default)(cfg, (0, _util.head)(ticks), (0, _util.last)(ticks));
  }
  if (tickInterval) {
    return (0, _interval.default)(min, max, tickInterval).ticks;
  }
  return ticks;
}