"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = calculatePowTicks;
var _math = require("../util/math");
var _pretty = _interopRequireDefault(require("../util/pretty"));
/**
 * 计算 Pow 的 ticks
 * @param cfg 度量的配置项
 * @returns 计算后的 ticks
 */
function calculatePowTicks(cfg) {
  var exponent = cfg.exponent,
    tickCount = cfg.tickCount;
  var max = Math.ceil((0, _math.calBase)(exponent, cfg.max));
  var min = Math.floor((0, _math.calBase)(exponent, cfg.min));
  var ticks = (0, _pretty.default)(min, max, tickCount).ticks;
  return ticks.map(function (tick) {
    var factor = tick >= 0 ? 1 : -1;
    return Math.pow(tick, exponent) * factor;
  });
}