"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.vec2Zero = exports.vec2AngleTo = void 0;
var _vec = require("gl-matrix/vec2");
/**
 *  expand Vec2
 */

var vec2Direction = function vec2Direction(v1, v2) {
  return v1[0] * v2[1] - v2[0] * v1[1];
};
var vec2Zero = function vec2Zero(v) {
  return v[0] === 0 && v[1] === 0;
};
exports.vec2Zero = vec2Zero;
var vec2AngleTo = function vec2AngleTo(v1, v2, direction) {
  var angle = (0, _vec.angle)(v1, v2);
  var angleLargeThanPI = vec2Direction(v1, v2) >= 0;
  if (direction) {
    if (angleLargeThanPI) {
      return Math.PI * 2 - angle;
    }
    return angle;
  }
  if (angleLargeThanPI) {
    return angle;
  }
  return Math.PI * 2 - angle;
};
exports.vec2AngleTo = vec2AngleTo;